Public Member Functions

# OGRLineString Class Reference

`#include <ogr_geometry.h>`

Inheritance diagram for OGRLineString:

List of all members.

## Public Member Functions
| OGRLineString ()
| Create an empty line string.
virtual int | WkbSize () const
| Returns size of related binary representation.
virtual OGRErr | importFromWkb (unsigned char *, int=-1)
| Assign geometry from well known binary data.
virtual OGRErr | exportToWkb (OGRwkbByteOrder, unsigned char *, OGRwkbVariant=wkbVariantOgc) const
| Convert a geometry into well known binary format.
virtual OGRErr | importFromWkt (char **)
| Assign geometry from well known text data.
virtual OGRErr | exportToWkt (char **ppszDstText) const
| Convert a geometry into well known text format.
virtual int | getDimension () const
| Get the dimension of this object.
virtual OGRGeometry * | clone () const
| Make a copy of this object.
virtual void | empty ()
| Clear geometry information. This restores the geometry to it's initial state after construction, and before assignment of actual geometry.
virtual void | getEnvelope (OGREnvelope *psEnvelope) const
| Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.
virtual void | getEnvelope (OGREnvelope3D *psEnvelope) const
| Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure.
virtual OGRBoolean | IsEmpty () const
| Returns TRUE (non-zero) if the object has no points.
virtual double | get_Length () const
| Returns the length of the curve.
virtual void | StartPoint (OGRPoint *) const
| Return the curve start point.
virtual void | EndPoint (OGRPoint *) const
| Return the curve end point.
virtual void | Value (double, OGRPoint *) const
| Fetch point at given distance along curve.
virtual double | Project (const OGRPoint *) const
| Project point on linestring.
virtual OGRLineString * | getSubLine (double, double, int) const
| Get the portion of linestring.
int | getNumPoints () const
| Fetch vertex count.
void | getPoint (int, OGRPoint *) const
| Fetch a point in line string.
double | getX (int i) const
| Get X at vertex.
double | getY (int i) const
| Get Y at vertex.
double | getZ (int i) const
| Get Z at vertex.
virtual OGRBoolean | Equals (OGRGeometry *) const
| Returns TRUE if two geometries are equivalent.
virtual void | setCoordinateDimension (int nDimension)
| Set the coordinate dimension.
void | setNumPoints (int nNewPointCount, int bZeroizeNewContent=TRUE)
| Set number of points in geometry.
void | setPoint (int, OGRPoint *)
| Set the location of a vertex in line string.
void | setPoint (int, double, double, double)
| Set the location of a vertex in line string.
void | setPoints (int, OGRRawPoint *, double *=NULL)
| Assign all points in a line string.
void | setPoints (int, double *padfX, double *padfY, double *padfZ=NULL)
| Assign all points in a line string.
void | addPoint (OGRPoint *)
| Add a point to a line string.
void | addPoint (double, double, double)
| Add a point to a line string.
void | getPoints (OGRRawPoint *, double *=NULL) const
| Returns all points of line string.
void | getPoints (void *pabyX, int nXStride, void *pabyY, int nYStride, void *pabyZ=NULL, int nZStride=0) const
| Returns all points of line string.
void | addSubLineString (const OGRLineString *, int nStartVertex=0, int nEndVertex=-1)
| Add a segment of another linestring to this one.
void | reversePoints (void)
| Reverse point order.
virtual OGRwkbGeometryType | getGeometryType () const
| Fetch geometry type.
virtual const char * | getGeometryName () const
| Fetch WKT name for geometry type.
virtual OGRErr | transform (OGRCoordinateTransformation *poCT)
| Apply arbitrary coordinate transformation to geometry.
virtual void | flattenTo2D ()
| Convert geometry to strictly 2D. In a sense this converts all Z coordinates to 0.0.
virtual void | segmentize (double dfMaxLength)
| Modify the geometry such it has no segment longer then the given distance.
virtual void | swapXY ()
| Swap x and y coordinates.

## Detailed Description

Concrete representation of a multi-vertex line.

## Member Function Documentation

void OGRLineString::addPoint | ( | OGRPoint * | poPoint | ) |

Add a point to a line string.

The vertex count of the line string is increased by one, and assigned from the passed location value.

There is no SFCOM analog to this method.

Parameters:

  | poPoint | the point to assign to the new vertex.

References OGRGeometry::getCoordinateDimension(), OGRPoint::getX(), OGRPoint::getY(), OGRPoint::getZ(), and setPoint().

Referenced by OGRLinearRing::closeRings(), getSubLine(), OGRBuildPolygonFromEdges(), and OGRLayer::SetSpatialFilterRect().

void OGRLineString::addPoint | ( | double | x,
|  | double | y,
|  | double | z |
| ) |  |  |

Add a point to a line string.

The vertex count of the line string is increased by one, and assigned from the passed location value.

There is no SFCOM analog to this method.

Parameters:

  | x | the X coordinate to assign to the new point.
  | y | the Y coordinate to assign to the new point.
  | z | the Z coordinate to assign to the new point (defaults to zero).

References setPoint().

void OGRLineString::addSubLineString | ( | const OGRLineString * | poOtherLine,
|  | int | nStartVertex = `0`,
|  | int | nEndVertex = `-1` |
| ) |  |  |

Add a segment of another linestring to this one.

Adds the request range of vertices to the end of this line string in an efficient manner. If the nStartVertex is larger than the nEndVertex then the vertices will be reversed as they are copied.

Parameters:

  | poOtherLine | the other OGRLineString.
  | nStartVertex | the first vertex to copy, defaults to 0 to start with the first vertex in the other linestring.
  | nEndVertex | the last vertex to copy, defaults to -1 indicating the last vertex of the other line string.

References getNumPoints(), and setNumPoints().

Referenced by OGRGeometryFactory::forceToLineString(), and OGRGeometryFactory::forceToMultiLineString().

OGRGeometry * OGRLineString::clone | ( |  | ) | const`[virtual]`

Make a copy of this object.

This method relates to the SFCOM IGeometry::clone() method.

This method is the same as the C function OGR_G_Clone().

Returns:
  a new object instance with the same geometry, and spatial reference system as the original.

Implements OGRGeometry.

Reimplemented in OGRLinearRing.

References OGRGeometry::assignSpatialReference(), OGRGeometry::getCoordinateDimension(), OGRGeometry::getSpatialReference(), OGRLineString(), setCoordinateDimension(), and setPoints().

void OGRLineString::empty | ( |  | ) | `[virtual]`

Clear geometry information. This restores the geometry to it's initial state after construction, and before assignment of actual geometry.

This method relates to the SFCOM IGeometry::Empty() method.

This method is the same as the C function OGR_G_Empty().

Implements OGRGeometry.

References setNumPoints().

Referenced by importFromWkt().

void OGRLineString::EndPoint | ( | OGRPoint * | poPoint | ) | const`[virtual]`

Return the curve end point.

This method relates to the SF COM ICurve::get_EndPoint() method.

Parameters:

  | poPoint | the point to be assigned the end location.

Implements OGRCurve.

References getPoint().

Referenced by OGRGeometryFactory::forceToLineString(), and Value().

OGRBoolean OGRLineString::Equals | ( | OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Returns TRUE if two geometries are equivalent.

This method is the same as the C function OGR_G_Equals().

Returns:
  TRUE if equivalent or FALSE otherwise.

Implements OGRGeometry.

References getGeometryType(), OGRGeometry::getGeometryType(), getNumPoints(), getX(), getY(), getZ(), OGRGeometry::IsEmpty(), and IsEmpty().

Referenced by OGRPolygon::Equals().

OGRErr OGRLineString::exportToWkb | ( | OGRwkbByteOrder | eByteOrder,
|  | unsigned char * | pabyData,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOgc` |
| ) |  |  | const`[virtual]`

Convert a geometry into well known binary format.

This method relates to the SFCOM IWks::ExportToWKB() method.

This method is the same as the C function OGR_G_ExportToWkb().

Parameters:

  | eByteOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  | pabyData | a buffer into which the binary representation is written. This buffer must be at least OGRGeometry::WkbSize() byte in size.
  | eWkbVariant | What standard to use when exporting geometries with three dimensions (or more). The default wkbVariantOgc is the historical OGR variant. wkbVariantIso is the variant defined in ISO SQL/MM and adopted by OGC for SFSQL 1.2.

Returns:
  Currently OGRERR_NONE is always returned.

Implements OGRGeometry.

Reimplemented in OGRLinearRing.

References OGRGeometry::getCoordinateDimension(), getGeometryType(), and wkbVariantIso.

OGRErr OGRLineString::exportToWkt | ( | char ** | ppszDstText | ) | const`[virtual]`

Convert a geometry into well known text format.

This method relates to the SFCOM IWks::ExportToWKT() method.

This method is the same as the C function OGR_G_ExportToWkt().

Parameters:

  | ppszDstText | a text buffer is allocated by the program, and assigned to the passed pointer. After use, *ppszDstText should be freed with OGRFree().

Returns:
  Currently OGRERR_NONE is always returned.

Implements OGRGeometry.

References OGRGeometry::getCoordinateDimension(), getGeometryName(), and IsEmpty().

Referenced by OGRPolygon::exportToWkt().

void OGRLineString::flattenTo2D | ( |  | ) | `[virtual]`

Convert geometry to strictly 2D. In a sense this converts all Z coordinates to 0.0.

This method is the same as the C function OGR_G_FlattenTo2D().

Implements OGRGeometry.

double OGRLineString::get_Length | ( |  | ) | const`[virtual]`

Returns the length of the curve.

This method relates to the SFCOM ICurve::get_Length() method.

Returns:
  the length of the curve, zero if the curve hasn't been initialized.

Implements OGRCurve.

Referenced by getSubLine().

int OGRLineString::getDimension | ( |  | ) | const`[virtual]`

Get the dimension of this object.

This method corresponds to the SFCOM IGeometry::GetDimension() method. It indicates the dimension of the object, but does not indicate the dimension of the underlying space (as indicated by OGRGeometry::getCoordinateDimension()).

This method is the same as the C function OGR_G_GetDimension().

Returns:
  0 for points, 1 for lines and 2 for surfaces.

Implements OGRGeometry.

void OGRLineString::getEnvelope | ( | OGREnvelope * | psEnvelope | ) | const`[virtual]`

Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope().

Parameters:

  | psEnvelope | the structure in which to place the results.

Implements OGRGeometry.

References IsEmpty().

Referenced by OGRPolygon::getEnvelope(), and getEnvelope().

void OGRLineString::getEnvelope | ( | OGREnvelope3D * | psEnvelope | ) | const`[virtual]`

Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope3D().

Parameters:

  | psEnvelope | the structure in which to place the results.

Since:
  OGR 1.9.0

Implements OGRGeometry.

References getEnvelope(), and IsEmpty().

const char * OGRLineString::getGeometryName | ( |  | ) | const`[virtual]`

Fetch WKT name for geometry type.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_GetGeometryName().

Returns:
  name used for this geometry type in well known text format. The returned pointer is to a static internal string and should not be modified or freed.

Implements OGRGeometry.

Reimplemented in OGRLinearRing.

Referenced by exportToWkt(), and importFromWkt().

OGRwkbGeometryType OGRLineString::getGeometryType | ( |  | ) | const`[virtual]`

Fetch geometry type.

Note that the geometry type may include the 2.5D flag. To get a 2D flattened version of the geometry type apply the wkbFlatten() macro to the return result.

This method is the same as the C function OGR_G_GetGeometryType().

Returns:
  the geometry type code.

Implements OGRGeometry.

Referenced by Equals(), and exportToWkb().

int OGRLineString::getNumPoints | ( |  | ) | const`[inline]`

Fetch vertex count.

Returns the number of vertices in the line string.

Returns:
  vertex count.

Referenced by addSubLineString(), OGRGeometry::dumpReadable(), Equals(), OGRGeometryFactory::forceToLineString(), OGRGeometryFactory::forceToMultiLineString(), getSubLine(), OGR_G_GetPoint(), OGR_G_GetPointCount(), OGR_G_GetPoints(), OGR_G_GetX(), OGR_G_GetY(), OGR_G_GetZ(), OGRBuildPolygonFromEdges(), and OGRGeometryFactory::organizePolygons().

void OGRLineString::getPoint | ( | int | i,
|  | OGRPoint * | poPoint |
| ) |  |  | const

Fetch a point in line string.

This method relates to the SFCOM ILineString::get_Point() method.

Parameters:

  | i | the vertex to fetch, from 0 to getNumPoints()-1.
  | poPoint | a point to initialize with the fetched point.

References OGRGeometry::getCoordinateDimension(), OGRPoint::setX(), OGRPoint::setY(), and OGRPoint::setZ().

Referenced by OGRLinearRing::closeRings(), EndPoint(), OGRGeometryFactory::organizePolygons(), and StartPoint().

void OGRLineString::getPoints | ( | OGRRawPoint * | paoPointsOut,
|  | double * | padfZ = `NULL` |
| ) |  |  | const

Returns all points of line string.

This method copies all points into user list. This list must be at least sizeof(OGRRawPoint) * OGRGeometry::getNumPoints() byte in size. It also copies all Z coordinates.

There is no SFCOM analog to this method.

Parameters:

  | paoPointsOut | a buffer into which the points is written.
  | padfZ | the Z values that go with the points (optional, may be NULL).

Referenced by getPoints(), and OGR_G_GetPoints().

void OGRLineString::getPoints | ( | void * | pabyX,
|  | int | nXStride,
|  | void * | pabyY,
|  | int | nYStride,
|  | void * | pabyZ = `NULL`,
|  | int | nZStride = `0` |
| ) |  |  | const

Returns all points of line string.

This method copies all points into user arrays. The user provides the stride between 2 consecutives elements of the array.

On some CPU architectures, care must be taken so that the arrays are properly aligned.

There is no SFCOM analog to this method.

Parameters:

  | pabyX | a buffer of at least (sizeof(double) * nXStride * nPointCount) bytes, may be NULL.
  | nXStride | the number of bytes between 2 elements of pabyX.
  | pabyY | a buffer of at least (sizeof(double) * nYStride * nPointCount) bytes, may be NULL.
  | nYStride | the number of bytes between 2 elements of pabyY.
  | pabyZ | a buffer of at last size (sizeof(double) * nZStride * nPointCount) bytes, may be NULL.
  | nZStride | the number of bytes between 2 elements of pabyZ.

Since:
  OGR 1.9.0

References getPoints().

OGRLineString * OGRLineString::getSubLine | ( | double | dfDistanceFrom,
|  | double | dfDistanceTo,
|  | int | bAsRatio |
| ) |  |  | const`[virtual]`

Get the portion of linestring.

The portion of the linestring extracted to new one. The input distances (maybe present as ratio of length of linestring) set begin and end of extracted portion.

Parameters:

  | dfDistanceFrom | The distance from the origin of linestring, where the subline should begins
  | dfDistanceTo | The distance from the origin of linestring, where the subline should ends
  | bAsRatio | The flag indicating that distances are the ratio of the linestring length.

Returns:
  a newly allocated linestring now owned by the caller, or NULL on failure.

Since:
  OGR 1.11.0

References addPoint(), OGRGeometry::assignSpatialReference(), get_Length(), OGRGeometry::getCoordinateDimension(), getNumPoints(), OGRGeometry::getSpatialReference(), OGRLineString(), and setCoordinateDimension().

double OGRLineString::getX | ( | int | iVertex | ) | const`[inline]`

Get X at vertex.

Returns the X value at the indicated vertex. If iVertex is out of range a crash may occur, no internal range checking is performed.

Parameters:

  | iVertex | the vertex to return, between 0 and getNumPoints()-1.

Returns:
  X value.

Referenced by OGRLinearRing::closeRings(), Equals(), OGR_G_GetPoint(), OGR_G_GetX(), and OGRBuildPolygonFromEdges().

double OGRLineString::getY | ( | int | iVertex | ) | const`[inline]`

Get Y at vertex.

Returns the Y value at the indicated vertex. If iVertex is out of range a crash may occur, no internal range checking is performed.

Parameters:

  | iVertex | the vertex to return, between 0 and getNumPoints()-1.

Returns:
  X value.

Referenced by OGRLinearRing::closeRings(), Equals(), OGR_G_GetPoint(), OGR_G_GetY(), and OGRBuildPolygonFromEdges().

double OGRLineString::getZ | ( | int | iVertex | ) | const

Get Z at vertex.

Returns the Z (elevation) value at the indicated vertex. If no Z value is available, 0.0 is returned. If iVertex is out of range a crash may occur, no internal range checking is performed.

Parameters:

  | iVertex | the vertex to return, between 0 and getNumPoints()-1.

Returns:
  Z value.

Referenced by OGRLinearRing::closeRings(), Equals(), OGR_G_GetPoint(), OGR_G_GetZ(), and OGRBuildPolygonFromEdges().

OGRErr OGRLineString::importFromWkb | ( | unsigned char * | pabyData,
|  | int | nSize = `-1` |
| ) |  |  | `[virtual]`

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKB() method.

This method is the same as the C function OGR_G_ImportFromWkb().

Parameters:

  | pabyData | the binary input data.
  | nSize | the size of pabyData in bytes, or zero if not known.

Returns:
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implements OGRGeometry.

Reimplemented in OGRLinearRing.

References setNumPoints(), and wkbLineString.

OGRErr OGRLineString::importFromWkt | ( | char ** | ppszInput | ) | `[virtual]`

Assign geometry from well known text data.

The object must have already been instantiated as the correct derived type of geometry object to match the text type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKT() method.

This method is the same as the C function OGR_G_ImportFromWkt().

Parameters:

  | ppszInput | pointer to a pointer to the source text. The pointer is updated to pointer after the consumed text.

Returns:
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implements OGRGeometry.

References empty(), and getGeometryName().

OGRBoolean OGRLineString::IsEmpty | ( |  | ) | const`[virtual]`

Returns TRUE (non-zero) if the object has no points.

Normally this returns FALSE except between when an object is instantiated and points have been assigned.

This method relates to the SFCOM IGeometry::IsEmpty() method.

Returns:
  TRUE if object is empty, otherwise FALSE.

Implements OGRGeometry.

Referenced by Equals(), exportToWkt(), and getEnvelope().

double OGRLineString::Project | ( | const OGRPoint * | poPoint | ) | const`[virtual]`

Project point on linestring.

The input point projeted on linestring. This is the shortest distance from point to the linestring. The distance from begin of linestring to the point projection returned.

This method is built on the GEOS library (GEOS >= 3.2.0), check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always return -1, issuing a CPLE_NotSupported error.

Returns:
  a distance from the begin of the linestring to the projected point.

Since:
  OGR 1.11.0

void OGRLineString::reversePoints | ( | void |  | ) |

Reverse point order.

This method updates the points in this line string in place reversing the point ordering (first for last, etc).

Referenced by OGRGeometryFactory::forceToLineString().

void OGRLineString::segmentize | ( | double | dfMaxLength | ) | `[virtual]`

Modify the geometry such it has no segment longer then the given distance.

Interpolated points will have Z and M values (if needed) set to 0. Distance computation is performed in 2d only

This function is the same as the C function OGR_G_Segmentize()

Parameters:

  | dfMaxLength | the maximum distance between 2 points after segmentization

Reimplemented from OGRGeometry.

References OGRGeometry::getCoordinateDimension().

void OGRLineString::setCoordinateDimension | ( | int | nNewDimension | ) | `[virtual]`

Set the coordinate dimension.

This method sets the explicit coordinate dimension. Setting the coordinate dimension of a geometry to 2 should zero out any existing Z values. Setting the dimension of a geometry collection will not necessarily affect the children geometries.

Parameters:

  | nNewDimension | New coordinate dimension value, either 2 or 3.

Reimplemented from OGRGeometry.

Referenced by clone(), OGRPolygon::exportToWkt(), and getSubLine().

void OGRLineString::setNumPoints | ( | int | nNewPointCount,
|  | int | bZeroizeNewContent = `TRUE` |
| ) |  |  |

Set number of points in geometry.

This method primary exists to preset the number of points in a linestring geometry before setPoint() is used to assign them to avoid reallocating the array larger with each call to addPoint().

This method has no SFCOM analog.

Parameters:

  | nNewPointCount | the new number of points for geometry.

References OGRGeometry::getCoordinateDimension().

Referenced by addSubLineString(), empty(), importFromWkb(), OGR_G_SetPointCount(), OGR_G_SetPoints(), setPoint(), and setPoints().

void OGRLineString::setPoint | ( | int | iPoint,
|  | OGRPoint * | poPoint |
| ) |  |  |

Set the location of a vertex in line string.

If iPoint is larger than the number of necessary the number of existing points in the line string, the point count will be increased to accomodate the request.

There is no SFCOM analog to this method.

Parameters:

  | iPoint | the index of the vertex to assign (zero based).
  | poPoint | the value to assign to the vertex.

References OGRGeometry::getCoordinateDimension(), OGRPoint::getX(), OGRPoint::getY(), and OGRPoint::getZ().

Referenced by addPoint(), OGRGeometryFactory::approximateArcAngles(), and OGR_G_SetPoints().

void OGRLineString::setPoint | ( | int | iPoint,
|  | double | xIn,
|  | double | yIn,
|  | double | zIn |
| ) |  |  |

Set the location of a vertex in line string.

If iPoint is larger than the number of necessary the number of existing points in the line string, the point count will be increased to accomodate the request.

There is no SFCOM analog to this method.

Parameters:

  | iPoint | the index of the vertex to assign (zero based).
  | xIn | input X coordinate to assign.
  | yIn | input Y coordinate to assign.
  | zIn | input Z coordinate to assign (defaults to zero).

References OGRGeometry::getCoordinateDimension(), and setNumPoints().

void OGRLineString::setPoints | ( | int | nPointsIn,
|  | OGRRawPoint * | paoPointsIn,
|  | double * | padfZ = `NULL` |
| ) |  |  |

Assign all points in a line string.

This method clears any existing points assigned to this line string, and assigns a whole new set. It is the most efficient way of assigning the value of a line string.

There is no SFCOM analog to this method.

Parameters:

  | nPointsIn | number of points being passed in paoPointsIn
  | paoPointsIn | list of points being assigned.
  | padfZ | the Z values that go with the points (optional, may be NULL).

References OGRGeometry::getCoordinateDimension(), and setNumPoints().

Referenced by clone(), OGRLinearRing::clone(), OGRPolygon::importFromWkt(), OGRMultiPolygon::importFromWkt(), OGRMultiLineString::importFromWkt(), OGR_G_SetPoints(), and transform().

void OGRLineString::setPoints | ( | int | nPointsIn,
|  | double * | padfX,
|  | double * | padfY,
|  | double * | padfZ = `NULL` |
| ) |  |  |

Assign all points in a line string.

This method clear any existing points assigned to this line string, and assigns a whole new set.

There is no SFCOM analog to this method.

Parameters:

  | nPointsIn | number of points being passed in padfX and padfY.
  | padfX | list of X coordinates of points being assigned.
  | padfY | list of Y coordinates of points being assigned.
  | padfZ | list of Z coordinates of points being assigned (defaults to NULL for 2D objects).

References setNumPoints().

void OGRLineString::StartPoint | ( | OGRPoint * | poPoint | ) | const`[virtual]`

Return the curve start point.

This method relates to the SF COM ICurve::get_StartPoint() method.

Parameters:

  | poPoint | the point to be assigned the start location.

Implements OGRCurve.

References getPoint().

Referenced by OGRGeometryFactory::forceToLineString(), and Value().

void OGRLineString::swapXY | ( |  | ) | `[virtual]`

Swap x and y coordinates.

Since:
  OGR 1.8.0

Reimplemented from OGRGeometry.

OGRErr OGRLineString::transform | ( | OGRCoordinateTransformation * | poCT | ) | `[virtual]`

Apply arbitrary coordinate transformation to geometry.

This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

Note that this method does not require that the geometry already have a spatial reference system. It will be assumed that they can be treated as having the source spatial reference system of the OGRCoordinateTransformation object, and the actual SRS of the geometry will be ignored. On successful completion the output OGRSpatialReference of the OGRCoordinateTransformation will be assigned to the geometry.

This method is the same as the C function OGR_G_Transform().

Parameters:

  | poCT | the transformation to apply.

Returns:
  OGRERR_NONE on success or an error code.

Implements OGRGeometry.

References OGRGeometry::assignSpatialReference(), OGRCoordinateTransformation::GetTargetCS(), setPoints(), and OGRCoordinateTransformation::TransformEx().

Referenced by OGRPolygon::transform().

void OGRLineString::Value | ( | double | dfDistance,
|  | OGRPoint * | poPoint |
| ) |  |  | const`[virtual]`

Fetch point at given distance along curve.

This method relates to the SF COM ICurve::get_Value() method.

Parameters:

  | dfDistance | distance along the curve at which to sample position. This distance should be between zero and get_Length() for this curve.
  | poPoint | the point to be assigned the curve position.

Implements OGRCurve.

References EndPoint(), OGRGeometry::getCoordinateDimension(), OGRPoint::setX(), OGRPoint::setY(), OGRPoint::setZ(), and StartPoint().

int OGRLineString::WkbSize | ( |  | ) | const`[virtual]`

Returns size of related binary representation.

This method returns the exact number of bytes required to hold the well known binary representation of this geometry object. Its computation may be slightly expensive for complex geometries.

This method relates to the SFCOM IWks::WkbSize() method.

This method is the same as the C function OGR_G_WkbSize().

Returns:
  size of binary representation in bytes.

Implements OGRGeometry.

Reimplemented in OGRLinearRing.

References OGRGeometry::getCoordinateDimension().

The documentation for this class was generated from the following files:

- ogr_geometry.h
- ogrlinestring.cpp

Generated for GDAL by 1.7.1.